/***************************************************************************
  Copyright (C) Nitsan Seniak 1989, 1990

  This file is part of the K2 compiler.
  Permission to copy this software, in whole or in part, to use this
  software for any lawful noncommercial purpose, and to redistribute
  this software is granted subject to the restriction that all copies
  made of this software must include this copyright notice in full.
  The author(s) makes no warranties or representations of any kind, either
  express or implied, including but not limited to implied warranties
  of merchantability or fitness for any particular purpose.
  All materials developed as a consequence of the use of this
  software shall duly acknowledge such use, in accordance with the usual
  standards of acknowledging credit in research.
 ***************************************************************************/ 

/*
 *  stdlib.h
 *
 *  Absent de la distribution gcc avec laquelle K2 a ete developpe.
 *  A recopier eventuellement dans /usr/include.
 *
 */

#define EXIT_SUCCESS			0
#define EXIT_FAILURE			(-1)
#define RAND_MAX				32767
#define MB_CUR_MAX				1

typedef struct { int quot, rem; } div_t;
typedef struct { long quot, rem; } ldiv_t;

#ifndef __size_t
#define __size_t
typedef unsigned long size_t;
#endif

#ifndef __wchar_t
#define __wchar_t
typedef char wchar_t;
#endif

double atof(char *);
int atoi(char *);
long atol(char *);
double strtod(char *, char **);
long strtol(char *, char **, int);
unsigned long strtoul(char *, char **, int);

int rand(void);
void srand(unsigned);

void *calloc(size_t, size_t);
void free(void *);
void *malloc(size_t);
void *realloc(void *, size_t);

void abort(void);
int atexit(void (*)());
void exit(int);
char *getenv(char *);
int system(char *);

void *bsearch(void *, void *, size_t, size_t, int (*)());
void qsort(void *, size_t, size_t, int (*)());

int abs(int);
div_t div(int, int);
long labs(long);
ldiv_t ldiv(long, long);

int mblen(char *, size_t);
